
#ifndef CATS_BUTTERFLIES_STATS_H
#define CATS_BUTTERFLIES_STATS_H

#include <assert.h>
#include "stats/statistics.h"
#include "threading/threading.h"

enum butterfly_stats {
    BF_STAT_MIN = 0,
    BF_STAT_POPULATED_FIT = 0,
    BF_STAT_POPULATED_UNFIT,
    BF_STAT_UNPOPULATED_FIT,
    BF_STAT_UNPOPULATED_UNFIT,
    BF_STAT_EXCLUDED,
    BF_RANDOM_WALK_DEPOSIT_COUNT,
    BF_RANDOM_WALK_COUNT,
    BF_RANDOM_WALK_STEP_COUNT,
    BF_OUTPUT_STAT_MAX,
    BF_CELLS_WITH_EGGS,
    BF_CELLS_WITH_EGGS_REMOVED,
    BF_STAT_MAX
};

const char *bf_get_stats_field_name(enum butterfly_stats which);
void bf_area_stats_gather(struct cats_grid *grid, struct cats_thread_info *ts);
void bf_stats_write(struct cats_configuration *conf, struct cats_grid *grid);

static inline void increase_custom_stat(struct statistics *stats, int64_t stat_id, int64_t by)
{
        assert(stats != NULL);
        assert(stat_id >= 0 && stat_id < stats->custom_stat_count);
        stats->custom_stats[stat_id] += by;
}



#endif //CATS_BUTTERFLIES_STATS_H
